# coding: utf-8

"""
    DataForSEO API documentation

    DataForSEO API is the starting point on your journey towards building powerful SEO software. With DataForSEO you can get all the data you need to build an efficient application while also saving your time and budget. DataForSEO API is using the REST technology for interchanging data between your application and our service. The data exchange is made through the widely used HTTP protocol, which allows applying our API to almost all programming languages.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from dataforseo_client.models.google_finance_market_trends_element import GoogleFinanceMarketTrendsElement
from typing import Optional, Set
from typing_extensions import Self

class SerpGoogleFinanceExploreAdvancedItem(BaseModel):
    """
    SerpGoogleFinanceExploreAdvancedItem
    """ # noqa: E501
    most_active: Optional[List[GoogleFinanceMarketTrendsElement]] = Field(default=None, description="array of items this array can take the following names: most_active, gainers, losers")
    gainers: Optional[List[GoogleFinanceMarketTrendsElement]] = None
    losers: Optional[List[GoogleFinanceMarketTrendsElement]] = None
    __properties: ClassVar[List[str]] = ["most_active", "gainers", "losers"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SerpGoogleFinanceExploreAdvancedItem from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in most_active (list)
        _items = []
        if self.most_active:
            for _item_most_active in self.most_active:
                if _item_most_active:
                    _items.append(_item_most_active.to_dict())
            _dict['most_active'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in gainers (list)
        _items = []
        if self.gainers:
            for _item_gainers in self.gainers:
                if _item_gainers:
                    _items.append(_item_gainers.to_dict())
            _dict['gainers'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in losers (list)
        _items = []
        if self.losers:
            for _item_losers in self.losers:
                if _item_losers:
                    _items.append(_item_losers.to_dict())
            _dict['losers'] = _items
        # set to None if most_active (nullable) is None
        # and model_fields_set contains the field
        if self.most_active is None and "most_active" in self.model_fields_set:
            _dict['most_active'] = None

        # set to None if gainers (nullable) is None
        # and model_fields_set contains the field
        if self.gainers is None and "gainers" in self.model_fields_set:
            _dict['gainers'] = None

        # set to None if losers (nullable) is None
        # and model_fields_set contains the field
        if self.losers is None and "losers" in self.model_fields_set:
            _dict['losers'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SerpGoogleFinanceExploreAdvancedItem from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "most_active": [GoogleFinanceMarketTrendsElement.from_dict(_item) for _item in obj["most_active"]] if obj.get("most_active") is not None else None,
            "gainers": [GoogleFinanceMarketTrendsElement.from_dict(_item) for _item in obj["gainers"]] if obj.get("gainers") is not None else None,
            "losers": [GoogleFinanceMarketTrendsElement.from_dict(_item) for _item in obj["losers"]] if obj.get("losers") is not None else None
        })
        return _obj


